<template>
  <div class="app-container">
    <el-form
      :model="queryParams"
      ref="queryForm"
      :inline="true"
      label-width="88px"
    >
      <el-form-item label="设备类型" prop="deviceType">
        <el-select
          v-model="queryParams.deviceType"
          clearable
          placeholder="请选择"
        >
          <el-option
            v-for="dict in deviceTypeOptions"
            :key="dict.dictValue"
            :label="dict.dictLabel"
            :value="dict.dictValue"
          ></el-option>
        </el-select>
      </el-form-item>

      <el-form-item label="设备序列号" prop="deviceSerialNum">
        <el-input
          v-model="queryParams.deviceSerialNum"
          placeholder="请输入设备序列号"
          clearable
          size="small"
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>

      <el-form-item>
        <el-button
          type="cyan"
          icon="el-icon-search"
          size="mini"
          @click="handleQuery"
          >搜索</el-button
        >
        <el-button
          type="info"
          icon="el-icon-refresh"
          size="mini"
          @click="resetQuery"
          >重置</el-button
        >
        <el-button
          type="primary"
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          >新增</el-button
        >
      </el-form-item>
    </el-form>

    <el-table :data="manageList">
      <el-table-column
        label="主键自增id"
        v-if="false"
        align="center"
        prop="deviceId"
      />
      <el-table-column label="油站名称" align="center" prop="stationName" />
      <el-table-column
        label="设备序列号"
        align="center"
        prop="deviceSerialNum"
      />
      <el-table-column label="设备厂家" align="center" prop="deviceFactory" />
      <el-table-column
        label="油站名称id"
        v-if="false"
        align="center"
        prop="stationId"
      />
      <el-table-column label="绑定油枪号" align="center" prop="gunNo" />
      <el-table-column
        label="操作"
        align="center"
        class-name="small-padding fixed-width"
      >
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            >修改</el-button
          >
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            >删除</el-button
          >
        </template>
      </el-table-column>
    </el-table>

    <pagination
      :total="100"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改油站设备管理对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="500px" append-to-body>
      <el-form ref="form" :model="form" :rules="rules" label-width="100px">
        <el-form-item label="设备编号" prop="deviceNo">
          <el-input v-model="form.deviceNo" placeholder="请输入设备编号" />
        </el-form-item>
        <el-form-item label="设备名称" prop="deviceName">
          <el-input v-model="form.deviceName" placeholder="请输入设备名称" />
        </el-form-item>
        <el-form-item label="设备序列号" prop="deviceSerialNum">
          <el-input
            v-model="form.deviceSerialNum"
            placeholder="请输入设备序列号"
          />
        </el-form-item>
        <el-form-item label="设备类型">
          <el-select
            v-model="form.deviceType"
            placeholder="请选择"
            clearable
            size="small"
          >
            <el-option
              v-for="dict in deviceTypeOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>

        <el-form-item label="绑定油枪号" prop="gunNo">
          <el-checkbox-group v-model="gunNoList">
            <el-checkbox
              v-for="item in checkList"
              :key="item.oilGunId"
              :label="item.oilGunNo"
              :value="item.oilGunNo"
            >
              {{ item.oilGunNo + "号枪/" + item.oilName }}
            </el-checkbox>
          </el-checkbox-group>
        </el-form-item>
        <el-form-item label="设备状态">
          <el-select
            v-model="form.deviceStatus"
            clearable
            size="small"
            placeholder="请选择"
          >
            <el-option
              v-for="dict in deviceStatusOptions"
              :key="dict.dictValue"
              :label="dict.dictLabel"
              :value="dict.dictValue"
            ></el-option>
          </el-select>
        </el-form-item>
        <el-form-item label="设备厂家" prop="deviceFactory">
          <el-input v-model="form.deviceFactory" placeholder="请输入设备厂家" />
        </el-form-item>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>

<script>
import {
  listManage,
  getManage,
  delManage,
  addManage,
  updateManage,
  exportManage,
  changeManageStatus,
} from "@/api/station/manage";
import { listGun } from "@/api/station/gun";
import { getDept } from "@/api/system/dept";
export default {
  name: "Manage",
  data() {
    return {
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,

      // 总条数
      total: 0,
      // 油站设备管理表格数据
      manageList: [],
      //油枪复选
      checkList: [],
      gunNoList: [],
      //设备状态
      deviceStatusOptions: [],
      //设备类型
      deviceTypeOptions: [],
      stationOptions: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        deviceNo: null,
        stationId: this.deptId,
        deviceType: null,
        deviceSerialNum: null,
      },
      deptId: null,
      queryInfo: {
        stationId: null,
      },
      // 查询参数
      deptInfo: {},
      query: {
        deptId: null,
      },
      // 表单参数
      form: {},
      // 表单校验
      rules: {},
    };
  },
  created() {
    this.getList();
    //字典设备状态
    this.getDicts("device_status").then((response) => {
      this.deviceStatusOptions = response.data;
    });
    //字典设备类型
    this.getDicts("device_type").then((response) => {
      this.deviceTypeOptions = response.data;
    });
  },
  methods: {
    /** 查询油站设备管理列表 */
    getList() {
      listManage(this.queryParams).then((response) => {
        this.manageList = response.rows;
        this.total = response.total;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        deviceId: null,
        deviceNo: null,
        deviceName: null,
        stationId: null,
        stationName: null,
        deviceType: null,
        deviceSerialNum: null,
        gunNo: null,
        deviceStatus: null,
        deviceFactory: null,
      };
      this.resetForm("form");
      this.gunNoList.length = 0;
    },
    deviceStatusFotmat(row, column) {
      if (row.deviceStatus === "1") {
        return "在用";
      } else if (row.deviceStatus === "2") {
        return "停用";
      }
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    /** 新增按钮操作 */
    handleAdd() {
      if (this.jiBie === 2) {
        this.open = true;
        this.title = "添加油站设备管理";
        this.form.stationId = this.deptInfo.deptId;
        this.form.stationName = this.deptInfo.deptName;
        this.queryInfo.stationId = this.deptInfo.deptId;
        listGun(this.queryInfo).then((response) => {
          console.log(response);
          this.checkList = response.rows;
        });
      } else {
        this.msgSuccess("请登录对应的账号");
      }
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const deviceId = row.deviceId;
      getManage(deviceId).then((response) => {
        this.form = response.data;
        if (this.form.gunNo != null && this.form.gunNo != "") {
          this.gunNoList = this.form.gunNo.split(",");
        }
        this.queryInfo.stationId = this.form.stationId;
        listGun(this.queryInfo).then((response) => {
          this.checkList = response.rows;
        });
        this.open = true;
        this.title = "修改油站设备管理";
      });
    },

    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate((valid) => {
        if (valid) {
          if (this.gunNoList != null && this.gunNoList.length > 0) {
            this.form.gunNo = this.gunNoList.toString();
          }
          if (this.form.deviceId != null) {
            updateManage(this.form).then((response) => {
              this.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addManage(this.form).then((response) => {
              this.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const deviceIds = row.deviceId;
      this.$confirm("是否确认删除油站设备管理", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return delManage(deviceIds);
        })
        .then(() => {
          this.getList();
          this.msgSuccess("删除成功");
        });
    },
    onInstitutionChang(e) {
      let obj = {};
      obj = this.stationOptions.find((item) => {
        //这里的userList就是上面遍历的数据源
        return item.deptId === e; //筛选出匹配数据
      });
      this.form.stationName = obj.deptName;
      this.queryInfo.stationId = obj.deptId;
      listGun(this.queryInfo).then((response) => {
        this.checkList = response.rows;
      });
    },
    /** 导出按钮操作 */
    handleExport() {
      const queryParams = this.queryParams;
      this.$confirm("是否确认导出所有油站设备管理数据项?", "警告", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(function () {
          return exportManage(queryParams);
        })
        .then((response) => {
          this.download(response.msg);
        });
    },
  },
};
</script>
